package ua.example.testseekbars;

import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.content.Intent;
import android.view.Gravity;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ProgressBar;
import android.widget.SeekBar;
import android.widget.SeekBar.OnSeekBarChangeListener;
import android.widget.TextView;
import android.widget.Toast;

public class MainActivity extends Activity {
	
	public SeekBar sbOne;
	public SeekBar sbTwo;
	public SeekBar sbThree;
	public SeekBar sbFour;
	
	public ProgressBar AllProgress;
	
	public CheckBox cbSave;
	
	public Button btnRandom;
	public Button btnRestart;
	public Button btnCrack;
	public Button btnSave;
	
	public int i1 = 0;
	public int i2 = 0;
	public int i3 = 0;
	public int i4 = 0;	
	public int scores = 0;	
	public int speed = 10;
	public int max = 1000;
	
	public boolean stop = false;
	
	public TextView tvProgresOne;
	public TextView tvProgresTwo;
	public TextView tvProgresThree;
	public TextView tvProgresFour;
	public TextView tvScores;
	
	public Handler handler;
	
	public EditText etCheat;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.main);
		
		tvScores = (TextView)findViewById(R.id.tv_scores);
		tvProgresOne = (TextView)findViewById(R.id.textView8);
		tvProgresTwo = (TextView)findViewById(R.id.tv_id);
		tvProgresThree = (TextView)findViewById(R.id.tv_score);
		tvProgresFour = (TextView)findViewById(R.id.textView4);
		
		tvProgresOne.setText(""+i1);
		tvProgresTwo.setText(""+i2);
		tvProgresThree.setText(""+i3);
		tvProgresFour.setText(""+i4);
		
		etCheat = (EditText)findViewById(R.id.et_cheat);
		
		cbSave = (CheckBox)findViewById(R.id.checkBox1);
		
		btnSave = (Button)findViewById(R.id.btn_save);
		btnSave.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				DialogWriteInDB saveScore = new DialogWriteInDB(MainActivity.this, scores, "  ");
				saveScore.show();
			}
		});
		
		sbOne = (SeekBar)findViewById(R.id.seekBar1);
		sbOne.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
			
			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				sbTwo.setEnabled(true);
				sbThree.setEnabled(true);
				sbFour.setEnabled(true);
			}
			
			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				if(seekBar.isInTouchMode()){
					sbTwo.setEnabled(false);
					sbThree.setEnabled(false);
					sbFour.setEnabled(false);
				}
			}
			
			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				// TODO Auto-generated method stub
				if(fromUser==true)
					i1 = progress;
				tvProgresOne.setText(""+progress);
			}
		});
		
		sbTwo = (SeekBar)findViewById(R.id.seekBar2);
		sbTwo.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
			
			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				sbOne.setEnabled(true);
				sbThree.setEnabled(true);
				sbFour.setEnabled(true);
			}
			
			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				if(seekBar.isInTouchMode()){
					sbOne.setEnabled(false);
					sbThree.setEnabled(false);
					sbFour.setEnabled(false);
				}
			}
			
			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				// TODO Auto-generated method stub
				if(fromUser == true)
					i2 = progress;
				tvProgresTwo.setText(""+progress);
			}
		});
		
		sbThree = (SeekBar)findViewById(R.id.seekBar3);
		sbThree.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
			
			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				sbOne.setEnabled(true);
				sbTwo.setEnabled(true);
				sbFour.setEnabled(true);
			}
			
			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				if(seekBar.isInTouchMode()){
					sbOne.setEnabled(false);
					sbTwo.setEnabled(false);
					sbFour.setEnabled(false);
				}
			}
			
			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				// TODO Auto-generated method stub
				if(fromUser == true)
					i3 = progress;
				tvProgresThree.setText(""+progress);
			}
		});
		
		sbFour = (SeekBar)findViewById(R.id.seekBar4);
		sbFour.setOnSeekBarChangeListener(new OnSeekBarChangeListener() {
			
			@Override
			public void onStopTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				sbOne.setEnabled(true);
				sbTwo.setEnabled(true);
				sbThree.setEnabled(true);
			}
			
			@Override
			public void onStartTrackingTouch(SeekBar seekBar) {
				// TODO Auto-generated method stub
				if(seekBar.isInTouchMode()){
					sbOne.setEnabled(false);
					sbTwo.setEnabled(false);
					sbThree.setEnabled(false);
				}
			}
			
			@Override
			public void onProgressChanged(SeekBar seekBar, int progress,
					boolean fromUser) {
				// TODO Auto-generated method stub
				if(fromUser == true)
					i4 = progress;
				tvProgresFour.setText(""+progress);
			}
		});
		
		AllProgress = (ProgressBar)findViewById(R.id.progressBar1);
		AllProgress.setOnLongClickListener(new OnLongClickListener() {
			
			@Override
			public boolean onLongClick(View v) {
				// TODO Auto-generated method stub
				if(etCheat.isEnabled())etCheat.setEnabled(false);
				else
					etCheat.setEnabled(true);
				return false;
			}
		});
		
		sbOne.setMax(max);
		sbTwo.setMax(max);
		sbThree.setMax(max);
		sbFour.setMax(max);		
		AllProgress.setMax(max*4-max/100);
		
		handler = new Handler();

		btnRandom = (Button)findViewById(R.id.btn_start_random);
		btnRandom.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				final Random random = new Random();
				final Timer timer = new Timer();
				timer.schedule(new TimerTask() {
					
					@Override
					public void run() {
						// TODO Auto-generated method stub
						handler.postDelayed(new Runnable() {
							
							@Override
							public void run() {
								// TODO Auto-generated method stub
								if((i1+i2+i3+i4)<(max*4))
								AllProgress.setProgress(i1+i2+i3+i4);
								
								if(stop==false){
									tvScores.setText(""+scores);
									scores++;
								}
								
								sbOne.setProgress(i1);
								if(i1<=max)
								tvProgresOne.setText(""+i1);
								if(i1<sbOne.getMax()+1 && stop==false) i1+=Math.abs(random.nextInt()%8);
								
								sbTwo.setProgress(i2);
								if(i2<=max)
								tvProgresTwo.setText(""+i2);
								if(i2<sbTwo.getMax()+1 && stop==false) i2+=Math.abs(random.nextInt()%8);
								
								sbThree.setProgress(i3);
								if(i3<=max)
								tvProgresThree.setText(""+i3);
								if(i3<sbThree.getMax()+1 && stop==false) i3+=Math.abs(random.nextInt()%8);
								
								sbFour.setProgress(i4);
								if(i4<=max)
								tvProgresFour.setText(""+i4);
								if(i4<sbFour.getMax()+1 && stop==false)i4+=Math.abs(random.nextInt()%8);
								
								if(i1>=max || i2>=max ||i3>=max || i4>=max ){
									if(i1>=max && stop==false){
										ShowToast(" 1 - WIN", R.drawable.one);
									}
									else
										if(i2>=max && stop==false){
											ShowToast(" 2 - WIN", R.drawable.two);
										}
										else
											if(i3>=max && stop==false){
												ShowToast(" 3 - WIN", R.drawable.three);
											}
											else
												if(i4>=max && stop==false){
													ShowToast(" 4 - WIN", R.drawable.four);
												}
									
									if(stop==false && cbSave.isChecked()==true){
										DialogWriteInDB saveScore = new DialogWriteInDB(MainActivity.this, scores, "  ");
										saveScore.show();
									}
									
									stop=true;
								}
								if(etCheat.getText().toString().length()!=0 && etCheat.getText().toString().compareTo("718293")==0)
								{
									btnCrack.setVisibility(Button.VISIBLE);
								}
								else
									btnCrack.setVisibility(Button.INVISIBLE);
							}
						}, 0);
					}
				}, 0, speed);
			}
		});
		btnRestart = (Button)findViewById(R.id.btn_ok);
		btnRestart.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				sbOne.setProgress(0);
				i1=0;
				sbTwo.setProgress(0);
				i2=0;
				sbThree.setProgress(0);
				i3=0;
				sbFour.setProgress(0);
				i4=0;
				stop=false;
				tvScores.setText(""+0);
				scores = 0;
			}
		});
		
		btnCrack = (Button)findViewById(R.id.btn_crck);
		btnCrack.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				i1 = -5000;
				i2 = -5000;
				i3 = -5000;
				i4 = -5000;
			}
		});
		
	}
	
	public void ShowToast(String msg, int resourseImg)
	{
		Toast tost = Toast.makeText(getApplicationContext(), msg, Toast.LENGTH_SHORT);
		tost.setGravity(Gravity.TOP, 0, 0);
		LinearLayout tView = (LinearLayout)tost.getView();
		ImageView img = new ImageView(getApplicationContext());
		img.setImageResource(resourseImg);
		tView.addView(img, 0);
		tost.show();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.main, menu);
		return true;
	}
	
	@Override
	public boolean onMenuItemSelected(int featureId, MenuItem item) {
		// TODO Auto-generated method stub
		if(item.getItemId()==R.id.action_scores){
			Intent intent = new Intent(MainActivity.this, ActivityTableScore.class);
			startActivity(intent);
			return true;
		}
		else
		return super.onMenuItemSelected(featureId, item);
	}
}
